/**
 * [js-crc]{@link https://github.com/emn178/js-crc}
 *
 * @namespace crc
 * @version 0.3.1
 * @author Chen, Yi-Cyuan [emn178@gmail.com]
 * @copyright Chen, Yi-Cyuan 2015-2024
 * @license MIT
 */
(()=>{var o="input is invalid type",t=(i="object"==typeof window)?window:{},i=!(i=t.JS_CRC_NO_WINDOW?!1:i)&&"object"==typeof self,i=(!t.JS_CRC_NO_NODE_JS&&"object"==typeof process&&process.versions&&process.versions.node?t=global:i&&(t=self),!t.JS_CRC_NO_COMMON_JS&&"object"==typeof module&&module.exports),r="function"==typeof define&&define.amd,f=!t.JS_CRC_NO_ARRAY_BUFFER&&"undefined"!=typeof ArrayBuffer,n="0123456789abcdef".split(""),d=["hex","array"],e=[{width:32,poly:79764919,init:4294967295,refin:!0,refout:!0,xorout:4294967295,name:"crc32"},{width:16,poly:32773,init:0,refin:!0,refout:!0,xorout:0,name:"crc16"}],h=Array.isArray,c=(!t.JS_CRC_NO_NODE_JS&&h||(h=function(t){return"[object Array]"===Object.prototype.toString.call(t)}),ArrayBuffer.isView);function p(i,r){return function(t){return new _(r).update(t)[i]()}}function s(t){var i,r,e=8-(t.width%8||8),s=(Math.ceil(t.width/8)%4||4)<<3,o=1<<s-1>>>0,s=s-8,f=t.width%32||32,n=32<t.width,h=(n?(i=t.init.slice(),r=t.poly.slice(),y(i,e),y(r,e),[r.join("-"),s,o]):(i=t.init<<e,[r=t.poly<<e,s,o])).join("_"),c={refin:t.refin,refout:t.refout,xorout:t.xorout,width:t.width,multiWords:n,bitOffset:e,msb:o,msbOffset:s,maskBits:f,mask:2**f-1,crc:i,poly:r,tableId:h},a=p("hex",c);a.create=function(){return new _(c)},a.update=function(t){return a.create().update(t)};for(var u=0;u<d.length;++u){var l=d[u];a[l]=p(l,c)}return a}function y(t,i){if(i){for(var r=0;r<t.length-1;++r)t[r]=t[r]<<i|t[r+1]>>>32-i;t[r]=t[r]<<i}}function a(t,i){for(var r=0;r<t.length;++r)t[r]^=i[r]}!f||!t.JS_CRC_NO_ARRAY_BUFFER_IS_VIEW&&c||(c=function(t){return"object"==typeof t&&t.buffer&&t.buffer.constructor===ArrayBuffer});var u={};function l(t,i,r,e){return u[t]||(u[t]=((t,i,r)=>{var e=[],s=h(t);for(s||(t=[t]),v=0;v<256;++v){for(var o=[v<<i],f=1;f<t.length;++f)o[f]=0;for(f=0;f<8;++f)if(o[0]&r){y(o,1);for(var n=0;n<t.length;++n)o[n]=o[n]^t[n]}else y(o,1);e[v]=s?o:o[0]}return e})(i,r,e)),u[t]}function m(t,i){for(var r=0,e=0;t;++e)1&t&&(r|=1<<i-1-e),t>>>=1;return r}for(var b=[],v=0;v<256;++v)b[v]=m(v,8);function _(t){this.options=t,this.refin=t.refin,this.multiWords=t.multiWords,this.bitOffset=t.bitOffset,this.msbOffset=t.msbOffset,this.maskBits=t.maskBits,this.mask=t.mask,this.table=l(t.tableId,t.poly,this.msbOffset,t.msb),this.multiWords?this.crc=t.crc.slice():this.crc=t.crc}_.prototype.update=function(t){if(this.finalized)throw new Error("finalize already called");var i,r,e=(t=>{var i=typeof t;if("string"==i)return[t,!0];if("object"==i&&null!==t){if(f&&t.constructor===ArrayBuffer)return[new Uint8Array(t),!1];if(h(t)||c(t))return[t,!1]}throw new Error(o)})(t),e=(t=e[0],e[1]),s=t.length;if(e)for(r=0;r<s;++r)(i=t.charCodeAt(r))<128?this.updateByte(i):(i<2048?this.updateByte(192|i>>6):(i<55296||57344<=i?this.updateByte(224|i>>12):(i=65536+((1023&i)<<10|1023&t.charCodeAt(++r)),this.updateByte(240|i>>18),this.updateByte(128|i>>12&63)),this.updateByte(128|i>>6&63)),this.updateByte(128|63&i));else for(r=0;r<s;++r)this.updateByte(t[r]);return this},_.prototype.updateByte=function(t){var i,r=this.crc;this.refin&&(t=b[t]),this.multiWords?(r[0]=r[0]^t<<this.msbOffset,i=this.table[r[0]>>this.msbOffset&255],y(r,8),a(r,i)):r=(r^=t<<this.msbOffset)<<8^this.table[r>>this.msbOffset&255],this.crc=r},_.prototype.finalize=function(){if(!this.finalized)if(this.finalized=!0,this.multiWords){var t=this.crc,i=this.bitOffset;if(i){for(var r=t.length-1;0<r;--r)t[r]=t[r-1]<<32-i|t[r]>>>i;t[r]=t[r]>>>i}if(this.crc[0]=this.crc[0]&this.mask,this.options.refout){y(this.crc,32-this.maskBits);for(var e=[],s=0;s<this.crc.length;++s)e[this.crc.length-s-1]=m(this.crc[s],32);this.crc=e}a(this.crc,this.options.xorout)}else this.crc=this.crc>>>this.bitOffset&this.mask,this.options.refout&&(this.crc=m(this.crc,this.options.width)),this.crc^=this.options.xorout},_.prototype.toString=_.prototype.hex=function(){this.finalize();var t="",i=this.crc,r=this.options.width;this.multiWords&&(i=i[0],r=r%32||32);for(var e=(Math.ceil(r/4)<<2)-4;0<=e;e-=4)t+=n[i>>e&15];if(this.multiWords)for(var s=1;s<this.crc.length;++s)for(i=this.crc[s],e=28;0<=e;e-=4)t+=n[i>>e&15];return t},_.prototype.array=function(){this.finalize();for(var t=new Array(Math.ceil(this.options.width/8)),i=this.crc,r=this.options.width,e=(this.multiWords&&(i=i[0],r=r%32||32),0),s=(Math.ceil(r/8)<<3)-8;0<=s;s-=8)t[e++]=i>>s&255;if(this.multiWords)for(var o=1;o<this.crc.length;++o)for(i=this.crc[o],s=24;0<=s;s-=8)t[e++]=i>>s&255;return t};for(var w,O={},v=0;v<e.length;++v)O[(w=e[v]).name]=s(w);if(O.createModel=s,i)module.exports=O;else{for(v=0;v<e.length;++v)t[(w=e[v]).name]=O[w.name];t.createModel=s,r&&define(function(){return O})}})();